(function (Drupal, drupalSettings, klaro) {

  'use strict';

  Drupal.behaviors.klaro = {
    attach: function attach(context) {
      if ("klaro" in drupalSettings && "config" in drupalSettings.klaro && context === document) {
        try {

          // Prepare regex.
          drupalSettings.klaro.config.apps.forEach(function (app, a_index) {
            app.cookies.forEach(function (cookie, c_index) {
              drupalSettings.klaro.config.apps[a_index]['cookies'][c_index] = [new RegExp(cookie[0], 'i'), cookie[1] || '/', cookie[2] || location.host];
            });
          });

          // Define a multiple future dom element event subscriber.
          function addFutureDomElementsEventListeners(selector, event, handler) {
            document.querySelector("body").addEventListener(event, function (evt) {
              var target = evt.target;
              while (target != null) {
                var isMatch = target.matches(selector);
                if (isMatch) {
                  handler(evt);
                  return;
                }
                target = target.parentElement;
              }
            }, true);
          }

          // Attach event listener.
          addFutureDomElementsEventListeners('[rel*="open-consent-manager"]', 'click', function (e) {
            e.preventDefault();
            if (document.getElementsByClassName('cm-learn-more').length > 0) {
              document.getElementsByClassName('cm-learn-more')[0].dispatchEvent(new Event('click'));
            }
            else {
              klaro.show(drupalSettings.klaro.config);
            }
          }, true);

          // Render the klaro consent manager.
          klaro.renderKlaro(drupalSettings.klaro.config);
        }
        catch (err) {
          console.log(err);
        }
      }
    },
  };
})(Drupal, drupalSettings, klaro);
